package jp.sf.beanbinder.strategy.swing;

import javax.swing.JLabel;
import javax.swing.JTextField;

import jp.sf.beanbinder.AlignType;
import jp.sf.beanbinder.Bind;
import jp.sf.beanbinder.strategy.AbsComponentStrategy;



public final class JLabelStrategy extends AbsComponentStrategy {

    public void updateDisplay(Bind bind, Object component, Object value) {
        try {
            JLabel textComponent = (JLabel)component;
            textComponent.setText( (value==null?"":value.toString()) );
            
            this.updateComponent(bind, component);
        }catch(Exception e) {
            throw new RuntimeException(e);
        }
    }
    public void updateComponent(Bind bind, Object component) {
        JLabel textComponent = (JLabel)component;
        
        if( textComponent instanceof JLabel ) {
            int align = JTextField.LEFT;
            if( bind.getProperty(0).getHorizon().equals(AlignType.LEFT) )align=JTextField.LEFT;
            if( bind.getProperty(0).getHorizon().equals(AlignType.CENTER) )align=JTextField.CENTER;
            if( bind.getProperty(0).getHorizon().equals(AlignType.RIGHT) )align=JTextField.RIGHT;
            ((JLabel)textComponent).setHorizontalAlignment(align);
        }
    }
    public void setEditable(Bind bind, Object component) {
    }
    public Object getValue(Bind bind, Object component) {
        return ((JLabel)component).getText();
    }
    
}
